///////////////////////////////////////////////////////////
//  Page.cs
//  Implementation of the Class Page
//  Generated by Enterprise Architect
//  Created on:      17-Feb-W008 1:35:19
///////////////////////////////////////////////////////////




using System.Drawing;
using System.Data.Linq.Mapping;
using System.Data.Linq;

namespace HomeDMSObjectModel
{
	[Table(Name="Pages")]
    public class Page {

		private EntityRef<Document> _document;
		private Image _image;
        private string _name;

        [Column(Name="page_name",DbType="nvarchar(100)")]
        public virtual string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        public Page()
        {
            _pageId = int.MinValue;
        }

        private int _pageId;

        [Column(Name="page_id",IsPrimaryKey=true,DbType="Int identity(1,1)",IsDbGenerated=true)]
        public virtual int PageId
        {
            get { return _pageId; }
            set { _pageId = value; }
        }

        [Column]
        internal int DocumentId { get; set; }

		[Association(Name="FK_PageDoc",Storage="_document",ThisKey="DocumentId",IsForeignKey=true)]
        public virtual Document Document{
			get{
				return _document.Entity;
			}
			set{
                Document prevValue = _document.Entity;
                if (prevValue != value || _document.HasLoadedOrAssignedValue == false)
                {
                    if (value != null)
                    {
                        DocumentId = value.DocumentId;
                        _document.Entity = value;
                    }                    
                }
  			}
		}

		[Column(Name="image_presentation",DbType="image",UpdateCheck=UpdateCheck.Never)]
        public virtual Image Image{
			get{
				return _image;
			}
			set{
				_image = value;
			}        
		}

        [Column(Name="page_order",DbType="int")]
        public int Order { get; set; }

        [Column]
        public virtual bool IsDefault { get; set; }

        public override bool Equals(object obj)
        {
            Page comp = obj as Page;
            if (comp == null)
                return false;

            if (this._pageId == int.MinValue || comp.PageId == int.MinValue)
            {
                return this.Name == comp.Name;
            }
            else
            {
                return this.PageId == comp.PageId;
            }             
        }

        public override int GetHashCode()
        {
            if (this.PageId == int.MinValue)
                return this.Name.GetHashCode();
            else
                return this.PageId.GetHashCode();
        }

	}//end Page

}//end namespace HomeDMS